diff -r e32ff462bf6e trytond/modules/account_invoice/invoice.py
--- a/trytond/modules/account_invoice/invoice.py	Mon Sep 10 15:27:42 2012 +0200
+++ b/trytond/modules/account_invoice/invoice.py	Mon Sep 24 20:36:39 2012 +0200
@@ -2027,59 +1843,67 @@
             '_parent_invoice.type'],
         depends=['manual'])
 
-    def __init__(self):
-        super(InvoiceTax, self).__init__()
-        self._constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(InvoiceTax, cls).__setup__()
+        cls._constraints += [
             ('check_company', 'You can not create invoice tax \n' \
                     'with account or code from a different invoice company!',
                     ['account', 'base_code', 'tax_code']),
-        ]
-        self._order.insert(0, ('sequence', 'ASC'))
-        self._error_messages.update({
+            ]
+        cls._order.insert(0, ('sequence', 'ASC'))
+        cls._error_messages.update({
             'modify': 'You can not modify tax from an invoice ' \
                     'that is opened, paid!',
             'create': 'You can not add a line to an invoice ' \
                     'that is open, paid or canceled!',
             })
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
 
-        super(InvoiceTax, self).init(module_name)
+        super(InvoiceTax, cls).__register__(module_name)
 
         # Migration from 2.4: drop required on sequence
         table.not_null_action('sequence', action='remove')
 
-    def default_base(self):
+    @staticmethod
+    def default_base():
         return Decimal('0.0')
 
-    def default_amount(self):
+    @staticmethod
+    def default_amount():
         return Decimal('0.0')
 
-    def default_manual(self):
+    @staticmethod
+    def default_manual():
         return True
 
-    def default_base_sign(self):
+    @staticmethod
+    def default_base_sign():
         return Decimal('1')
 
-    def default_tax_sign(self):
+    @staticmethod
+    def default_tax_sign():
         return Decimal('1')
 
-    def on_change_tax(self, values):
-        pool = Pool()
-        tax_obj = pool.get('account.tax')
-        invoice_obj = pool.get('account.invoice')
+    def on_change_tax(self):
+        Tax = Pool().get('account.tax')
         changes = {}
-        if values.get('tax'):
-            invoice_values = dict(
-                (f[16:], v) for f, v in values.iteritems()
-                if f.startswith('_parent_invoice.'))
-            context = invoice_obj.get_tax_context(invoice_values)
+        if self.tax:
+            if self.invoice:
+                context = self.invoice.get_tax_context()
+            else:
+                context = {}
             with Transaction().set_context(**context):
-                tax = tax_obj.browse(values['tax'])
+                tax = Tax(self.tax.id)
             changes['description'] = tax.description
-            invoice_type = values.get('_parent_invoice.type', 'out_invoice')
+            if self.invoice and self.invoice.type:
+                invoice_type = self.invoice.type
+            else:
+                invoice_type = 'out_invoice'
             if invoice_type in ('out_invoice', 'in_invoice'):
                 changes['base_code'] = tax.invoice_base_code.id
                 changes['base_sign'] = tax.invoice_base_sign
@@ -2094,92 +1918,85 @@
                 changes['account'] = tax.credit_note_account.id
         return changes
 
-    def on_change_with_amount(self, values):
-        pool = Pool()
-        tax_obj = pool.get('account.tax')
-        if values.get('tax') and values.get('manual', False):
-            tax_id = values['tax']
-            base = values.get('base') or Decimal(0)
-            for tax in tax_obj.compute([tax_id], base, 1):
-                if (tax['tax'].id == tax_id
-                        and tax['base'] == values.get('base')):
+    def on_change_with_amount(self):
+        Tax = Pool().get('account.tax')
+        if self.tax and self.manual:
+            tax = self.tax
+            base = self.base or Decimal(0)
+            for tax in Tax.compute([tax], base, 1):
+                if (tax['tax'] == tax
+                        and tax['base'] == self.base):
                     return tax['amount']
-        return values.get('amount')
+        return self.amount
 
-    def check_modify(self, ids):
+    @classmethod
+    def check_modify(cls, taxes):
         '''
         Check if the taxes can be modified
         '''
-        for tax in self.browse(ids):
+        for tax in taxes:
             if tax.invoice.state in ('open', 'paid'):
-                self.raise_user_error('modify')
-        return
+                cls.raise_user_error('modify')
 
-    def get_sequence_number(self, ids, name):
-        res = {}
-        for tax in self.browse(ids):
-            res[tax.id] = 0
-            i = 1
-            for tax2 in tax.invoice.taxes:
-                if tax2.id == tax.id:
-                    res[tax.id] = i
-                    break
-                i += 1
-        return res
+    def get_sequence_number(self, name):
+        i = 1
+        for tax in self.invoice.taxes:
+            if tax == self:
+                return i
+            i += 1
+        return 0
 
-    def delete(self, ids):
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        self.check_modify(ids)
-        return super(InvoiceTax, self).delete(ids)
+    @classmethod
+    def delete(cls, taxes):
+        cls.check_modify(taxes)
+        super(InvoiceTax, cls).delete(taxes)
 
-    def write(self, ids, vals):
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        self.check_modify(ids)
-        return super(InvoiceTax, self).write(ids, vals)
+    @classmethod
+    def write(cls, taxes, vals):
+        cls.check_modify(taxes)
+        super(InvoiceTax, cls).write(taxes, vals)
 
-    def create(self, vals):
-        invoice_obj = Pool().get('account.invoice')
+    @classmethod
+    def create(cls, vals):
+        Invoice = Pool().get('account.invoice')
         if vals.get('invoice'):
-            invoice = invoice_obj.browse(vals['invoice'])
+            invoice = Invoice(vals['invoice'])
             if invoice.state in ('open', 'paid', 'cancel'):
-                self.raise_user_error('create')
-        return super(InvoiceTax, self).create(vals)
+                cls.raise_user_error('create')
+        return super(InvoiceTax, cls).create(vals)
 
-    def check_company(self, ids):
-        for tax in self.browse(ids):
-            company = tax.invoice.company
-            if tax.account.company.id != company.id:
+    def check_company(self):
+        company = self.invoice.company
+        if self.account.company != company:
+            return False
+        if self.base_code:
+            if self.base_code.company != company:
                 return False
-            if tax.base_code:
-                if tax.base_code.company.id != company.id:
-                    return False
-            if tax.tax_code:
-                if tax.tax_code.company.id != company.id:
-                    return False
+        if self.tax_code:
+            if self.tax_code.company != company:
+                return False
         return True
 
-    def get_move_line(self, tax):
+    def get_move_line(self):
         '''
         Return a list of move lines values for invoice tax
         '''
-        currency_obj = Pool().get('currency.currency')
+        Currency = Pool().get('currency.currency')
         res = {}
-        if not tax.amount:
+        if not self.amount:
             return []
-        res['name'] = tax.description
-        if tax.invoice.currency.id != tax.invoice.company.currency.id:
-            with Transaction().set_context(date=tax.invoice.currency_date):
-                amount = currency_obj.compute(tax.invoice.currency.id,
-                        tax.amount, tax.invoice.company.currency.id)
-            res['amount_second_currency'] = tax.amount
-            res['second_currency'] = tax.invoice.currency.id
+        res['name'] = self.description
+        if self.invoice.currency != self.invoice.company.currency:
+            with Transaction().set_context(date=self.invoice.currency_date):
+                amount = Currency.compute(self.invoice.currency, self.amount,
+                    self.invoice.company.currency)
+            res['amount_second_currency'] = self.amount
+            res['second_currency'] = self.invoice.currency.id
         else:
-            amount = tax.amount
+            amount = self.amount
             res['amount_second_currency'] = Decimal('0.0')
             res['second_currency'] = None
-        if tax.invoice.type in ('in_invoice', 'out_credit_note'):
+        if self.invoice.type in ('in_invoice', 'out_credit_note'):
             if amount >= Decimal('0.0'):
                 res['debit'] = amount
                 res['credit'] = Decimal('0.0')
@@ -2195,17 +2012,17 @@
             else:
                 res['debit'] = - amount
                 res['credit'] = Decimal('0.0')
-        res['account'] = tax.account.id
-        res['party'] = tax.invoice.party.id
-        if tax.tax_code:
+        res['account'] = self.account.id
+        res['party'] = self.invoice.party.id
+        if self.tax_code:
             res['tax_lines'] = [('create', {
-                'code': tax.tax_code.id,
-                'amount': amount * tax.tax_sign,
-                'tax': tax.tax and tax.tax.id or None
+                'code': self.tax_code.id,
+                'amount': amount * self.tax_sign,
+                'tax': self.tax and self.tax.id or None
             })]
         return [res]
 
-    def _credit(self, tax):
+    def _credit(self):
         '''
         Return values to credit tax.
         '''
@@ -2213,27 +2030,21 @@
 
         for field in ('description', 'sequence', 'base', 'amount',
                 'manual', 'base_sign', 'tax_sign'):
-            res[field] = tax[field]
+            res[field] = getattr(self, field)
 
         for field in ('account', 'base_code', 'tax_code', 'tax'):
-            res[field] = tax[field].id
+            res[field] = getattr(self, field).id
         return res
 
-InvoiceTax()
-
 
 class PrintInvoiceWarning(ModelView):
     'Print Invoice Report Warning'
-    _name = 'account.invoice.print.warning'
-    _description = __doc__
-
-PrintInvoiceWarning()
+    __name__ = 'account.invoice.print.warning'
 
 
 class PrintInvoice(Wizard):
     'Print Invoice Report'
-    _name = 'account.invoice.print'
-
+    __name__ = 'account.invoice.print'
     start = StateTransition()
     warning = StateView('account.invoice.print.warning',
         'account_invoice.print_warning_view_form', [
@@ -2242,81 +2053,79 @@
             ])
     print_ = StateAction('account_invoice.report_invoice')
 
-    def transition_start(self, session):
+    def transition_start(self):
         if len(Transaction().context['active_ids']) > 1:
             return 'warning'
         return 'print_'
 
-    def do_print_(self, session, action):
+    def do_print_(self, action):
         data = {}
         data['id'] = Transaction().context['active_ids'].pop()
         data['ids'] = [data['id']]
         return action, data
 
-    def transition_print_(self, session):
+    def transition_print_(self):
         if Transaction().context['active_ids']:
             return 'print_'
         return 'end'
 
-PrintInvoice()
-
 
 class InvoiceReport(Report):
-    _name = 'account.invoice'
+    __name__ = 'account.invoice'
 
-    def __init__(self):
-        super(InvoiceReport, self).__init__()
-        self._rpc['execute'] = True
+    @classmethod
+    def __setup__(cls):
+        super(InvoiceReport, cls).__setup__()
+        cls.__rpc__['execute'] = RPC(False)
 
-    def execute(self, ids, data):
-        invoice_obj = Pool().get('account.invoice')
+    @classmethod
+    def execute(cls, ids, data):
+        Invoice = Pool().get('account.invoice')
 
-        res = super(InvoiceReport, self).execute(ids, data)
+        res = super(InvoiceReport, cls).execute(ids, data)
         if len(ids) > 1:
             res = (res[0], res[1], True, res[3])
         else:
-            invoice = invoice_obj.browse(ids[0])
+            invoice = Invoice(ids[0])
             if invoice.number:
                 res = (res[0], res[1], res[2], res[3] + ' - ' + invoice.number)
         return res
 
-    def _get_objects(self, ids, model, data):
-        invoice_obj = Pool().get('account.invoice')
+    @classmethod
+    def _get_records(cls, ids, model, data):
+        with Transaction().set_context(language=False):
+            return super(InvoiceReport, cls)._get_records(ids[:1], model, data)
 
-        with Transaction().set_context(language=False):
-            return invoice_obj.browse([ids[0]])
+    @classmethod
+    def parse(cls, report, records, data, localcontext):
+        pool = Pool()
+        User = pool.get('res.user')
+        Invoice = pool.get('account.invoice')
 
-    def parse(self, report, objects, data, localcontext):
-        user_obj = Pool().get('res.user')
-        invoice_obj = Pool().get('account.invoice')
-
-        invoice = objects[0]
+        invoice = records[0]
 
         if invoice.invoice_report_cache:
             return (invoice.invoice_report_format,
                 invoice.invoice_report_cache)
 
-        user = user_obj.browse(Transaction().user)
+        user = User(Transaction().user)
         localcontext['company'] = user.company
-        res = super(InvoiceReport, self).parse(report, objects, data,
+        res = super(InvoiceReport, cls).parse(report, records, data,
                 localcontext)
         # If the invoice is open or paid and the report not saved in
         # invoice_report_cache there was an error somewhere. So we save it now
         # in invoice_report_cache
         if invoice.state in ('open', 'paid'):
-            invoice_obj.write(invoice.id, {
+            Invoice.write([invoice], {
                 'invoice_report_format': res[0],
                 'invoice_report_cache': res[1],
                 })
         return res
 
-InvoiceReport()
-
 
 class PayInvoiceStart(ModelView):
     'Pay Invoice'
-    _name = 'account.invoice.pay.start'
-    _description = __doc__
+    __name__ = 'account.invoice.pay.start'
     amount = fields.Numeric('Amount', digits=(16, Eval('currency_digits', 2)),
         depends=['currency_digits'], required=True)
     currency = fields.Many2One('currency.currency', 'Currency', required=True)
@@ -2327,27 +2136,24 @@
             domain=[('type', '=', 'cash')])
     date = fields.Date('Date', required=True)
 
-    def default_date(self):
-        date_obj = Pool().get('ir.date')
-        return date_obj.today()
+    @staticmethod
+    def default_date():
+        Date = Pool().get('ir.date')
+        return Date.today()
 
-    def default_currency_digits(self):
+    @staticmethod
+    def default_currency_digits():
         return 2
 
-    def on_change_with_currency_digits(self, vals):
-        currency_obj = Pool().get('currency.currency')
-        if vals.get('currency'):
-            currency = currency_obj.browse(vals['currency'])
-            return currency.digits
+    def on_change_with_currency_digits(self):
+        if self.currency:
+            return self.currency.digits
         return 2
 
-PayInvoiceStart()
-
 
 class PayInvoiceAsk(ModelView):
     'Pay Invoice'
-    _name = 'account.invoice.pay.ask'
-    _description = __doc__
+    __name__ = 'account.invoice.pay.ask'
     type = fields.Selection([
         ('writeoff', 'Write-Off'),
         ('partial', 'Partial Payment'),
@@ -2403,37 +2209,31 @@
     company = fields.Many2One('company.company', 'Company', readonly=True)
     invoice = fields.Many2One('account.invoice', 'Invoice', readonly=True)
 
-    def default_type(self):
+    @staticmethod
+    def default_type():
         return 'partial'
 
-    def on_change_lines(self, vals):
-        pool = Pool()
-        currency_obj = pool.get('currency.currency')
-        line_obj = pool.get('account.move.line')
-        invoice_obj = pool.get('account.invoice')
+    def on_change_lines(self):
+        Currency = Pool().get('currency.currency')
 
         res = {}
-        invoice = invoice_obj.browse(vals['invoice'])
-        with Transaction().set_context(date=invoice.currency_date):
-            amount = currency_obj.compute(vals['currency'], vals['amount'],
-                    vals['currency_writeoff'])
+        with Transaction().set_context(date=self.invoice.currency_date):
+            amount = Currency.compute(self.currency, self.amount,
+                self.currency_writeoff)
 
         res['amount_writeoff'] = Decimal('0.0')
-        for line in line_obj.browse(vals['lines']):
+        for line in self.lines:
             res['amount_writeoff'] += line.debit - line.credit
-        if invoice.type in ('in_invoice', 'out_credit_note'):
+        if self.invoice.type in ('in_invoice', 'out_credit_note'):
             res['amount_writeoff'] = - res['amount_writeoff'] - amount
         else:
             res['amount_writeoff'] = res['amount_writeoff'] - amount
         return res
 
-PayInvoiceAsk()
-
 
 class PayInvoice(Wizard):
     'Pay Invoice'
-    _name = 'account.invoice.pay'
-
+    __name__ = 'account.invoice.pay'
     start = StateView('account.invoice.pay.start',
         'account_invoice.pay_start_view_form', [
             Button('Cancel', 'end', 'tryton-cancel'),
@@ -2447,17 +2247,18 @@
             ])
     pay = StateTransition()
 
-    def __init__(self):
-        super(PayInvoice, self).__init__()
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(PayInvoice, cls).__setup__()
+        cls._error_messages.update({
             'amount_greater_amount_to_pay': 'You can not create a partial ' \
                     'payment with an amount greater then the amount to pay!',
             })
 
-    def default_start(self, session, fields):
-        invoice_obj = Pool().get('account.invoice')
+    def default_start(self, fields):
+        Invoice = Pool().get('account.invoice')
         default = {}
-        invoice = invoice_obj.browse(Transaction().context['active_id'])
+        invoice = Invoice(Transaction().context['active_id'])
         default['currency'] = invoice.currency.id
         default['currency_digits'] = invoice.currency.digits
         default['amount'] = (invoice.amount_to_pay_today
@@ -2465,52 +2266,52 @@
         default['description'] = invoice.number
         return default
 
-    def transition_choice(self, session):
-        invoice_obj = Pool().get('account.invoice')
-        currency_obj = Pool().get('currency.currency')
+    def transition_choice(self):
+        pool = Pool()
+        Invoice = pool.get('account.invoice')
+        Currency = pool.get('currency.currency')
 
-        invoice = invoice_obj.browse(Transaction().context['active_id'])
+        invoice = Invoice(Transaction().context['active_id'])
 
-        with Transaction().set_context(date=session.start.date):
-            amount = currency_obj.compute(session.start.currency.id,
-                session.start.amount, invoice.company.currency.id)
-        _, remainder = invoice_obj.get_reconcile_lines_for_amount(invoice,
-            amount)
+        with Transaction().set_context(date=self.start.date):
+            amount = Currency.compute(self.start.currency,
+                self.start.amount, invoice.company.currency)
+        _, remainder = invoice.get_reconcile_lines_for_amount(amount)
         if remainder == Decimal('0.0') and amount <= invoice.amount_to_pay:
             return 'pay'
         return 'ask'
 
-    def default_ask(self, session, fields):
+    def default_ask(self, fields):
         pool = Pool()
-        invoice_obj = pool.get('account.invoice')
-        currency_obj = pool.get('currency.currency')
-        line_obj = pool.get('account.move.line')
+        Invoice = pool.get('account.invoice')
+        Currency = pool.get('currency.currency')
+        Line = pool.get('account.move.line')
 
         default = {}
-        invoice = invoice_obj.browse(Transaction().context['active_id'])
+        invoice = Invoice(Transaction().context['active_id'])
         default['lines_to_pay'] = [x.id for x in invoice.lines_to_pay
                 if not x.reconciliation]
 
-        default['amount'] = session.start.amount
-        default['currency'] = session.start.currency.id
-        default['currency_digits'] = session.start.currency_digits
+        default['amount'] = self.start.amount
+        default['currency'] = self.start.currency.id
+        default['currency_digits'] = self.start.currency_digits
         default['company'] = invoice.company.id
 
-        with Transaction().set_context(date=session.start.date):
-            amount = currency_obj.compute(session.start.currency.id,
-                session.start.amount, invoice.company.currency.id)
+        with Transaction().set_context(date=self.start.date):
+            amount = Currency.compute(self.start.currency.id,
+                self.start.amount, invoice.company.currency.id)
 
-        if currency_obj.is_zero(invoice.company.currency, amount):
+        if invoice.company.currency.is_zero(amount):
             default['lines'] = [x.id for x in invoice.lines_to_pay]
         else:
             default['lines'], _ = \
-                invoice_obj.get_reconcile_lines_for_amount(invoice, amount)
+                invoice.get_reconcile_lines_for_amount(amount)
         for line_id in default['lines'][:]:
             if line_id not in default['lines_to_pay']:
                 default['lines'].remove(line_id)
 
         default['amount_writeoff'] = Decimal('0.0')
-        for line in line_obj.browse(default['lines']):
+        for line in Line.browse(default['lines']):
             default['amount_writeoff'] += line.debit - line.credit
         for line in invoice.payment_lines:
             default['amount_writeoff'] += line.debit - line.credit
@@ -2525,81 +2326,75 @@
         default['payment_lines'] = [x.id for x in invoice.payment_lines
                 if not x.reconciliation]
 
-        if amount > invoice.amount_to_pay \
-                or currency_obj.is_zero(invoice.company.currency, amount):
+        if (amount > invoice.amount_to_pay
+                or invoice.company.currency.is_zero(amount)):
             default['type'] = 'writeoff'
         return default
 
-    def transition_pay(self, session):
+    def transition_pay(self):
         pool = Pool()
-        invoice_obj = pool.get('account.invoice')
-        currency_obj = pool.get('currency.currency')
-        move_line_obj = pool.get('account.move.line')
+        Invoice = pool.get('account.invoice')
+        Currency = pool.get('currency.currency')
+        MoveLine = pool.get('account.move.line')
 
-        invoice = invoice_obj.browse(Transaction().context['active_id'])
+        invoice = Invoice(Transaction().context['active_id'])
 
-        with Transaction().set_context(date=session.start.date):
-            amount = currency_obj.compute(session.start.currency.id,
-                session.start.amount, invoice.company.currency.id)
+        with Transaction().set_context(date=self.start.date):
+            amount = Currency.compute(self.start.currency,
+                self.start.amount, invoice.company.currency)
 
         reconcile_lines, remainder = \
-            invoice_obj.get_reconcile_lines_for_amount(invoice, amount)
+            invoice.get_reconcile_lines_for_amount(amount)
 
         amount_second_currency = None
         second_currency = None
-        if session.start.currency.id != invoice.company.currency.id:
-            amount_second_currency = session.start.amount
-            second_currency = session.start.currency
+        if self.start.currency != invoice.company.currency:
+            amount_second_currency = self.start.amount
+            second_currency = self.start.currency
 
         if amount > invoice.amount_to_pay and \
-                session.ask.type != 'writeoff':
+                self.ask.type != 'writeoff':
             self.raise_user_error('amount_greater_amount_to_pay')
 
-        line_id = None
-        if not currency_obj.is_zero(invoice.company.currency, amount):
-            line_id = invoice_obj.pay_invoice(invoice.id, amount,
-                session.start.journal.id, session.start.date,
-                session.start.description, amount_second_currency,
+        line = None
+        if not invoice.company.currency.is_zero(amount):
+            line = invoice.pay_invoice(amount,
+                self.start.journal, self.start.date,
+                self.start.description, amount_second_currency,
                 second_currency)
 
         if remainder != Decimal('0.0'):
-            if session.ask.type == 'writeoff':
-                line_ids = [x.id for x in session.ask.lines] + \
-                    [x.id for x in invoice.payment_lines
-                        if not x.reconciliation]
-                if line_id and line_id not in line_ids:
+            if self.ask.type == 'writeoff':
+                lines = [l for l in self.ask.lines] + \
+                    [l for l in invoice.payment_lines
+                        if not l.reconciliation]
+                if line and line not in lines:
                     # Add new payment line if payment_lines was cached before
                     # its creation
-                    line_ids += [line_id]
-                if line_ids:
-                    move_line_obj.reconcile(line_ids,
-                        journal_id=session.ask.journal_writeoff.id,
-                        date=session.start.date,
-                        account_id=session.ask.account_writeoff.id)
+                    lines += [line]
+                if lines:
+                    MoveLine.reconcile(lines,
+                        journal=self.ask.journal_writeoff,
+                        date=self.start.date,
+                        account=self.ask.account_writeoff)
         else:
-            if line_id:
-                reconcile_lines += [line_id]
+            if line:
+                reconcile_lines += [line]
             if reconcile_lines:
-                move_line_obj.reconcile(reconcile_lines)
+                MoveLine.reconcile(reconcile_lines)
         return 'end'
 
-PayInvoice()
-
 
 class CreditInvoiceStart(ModelView):
     'Credit Invoice Init'
-    _name = 'account.invoice.credit.start'
-    _description = __doc__
+    __name__ = 'account.invoice.credit.start'
     with_refund = fields.Boolean('With Refund', help='If true, ' \
             'the current invoice(s) will be paid.')
 
-CreditInvoiceStart()
-
 
 class CreditInvoice(Wizard):
     'Credit Invoice'
-    _name = 'account.invoice.credit'
-
+    __name__ = 'account.invoice.credit'
     start = StateView('account.invoice.credit.start',
         'account_invoice.credit_start_view_form', [
             Button('Cancel', 'end', 'tryton-cancel'),
@@ -2607,45 +2402,44 @@
             ])
     credit = StateAction('account_invoice.act_invoice_form')
 
-    def __init__(self):
-        super(CreditInvoice, self).__init__()
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(CreditInvoice, cls).__setup__()
+        cls._error_messages.update({
             'refund_non_open': 'You can not credit with refund ' \
                     'an invoice that is not opened!',
             'refund_with_payement': 'You can not credit with refund ' \
                     'an invoice with payments!',
             })
 
-    def default_start(self, session, fields):
-        invoice_obj = Pool().get('account.invoice')
+    def default_start(self, fields):
+        Invoice = Pool().get('account.invoice')
         default = {
             'with_refund': True,
-        }
-        for invoice in invoice_obj.browse(Transaction().context['active_ids']):
+            }
+        for invoice in Invoice.browse(Transaction().context['active_ids']):
             if invoice.state != 'open' or invoice.payment_lines:
                 default['with_refund'] = False
                 break
         return default
 
-    def do_credit(self, session, action):
+    def do_credit(self, action):
         pool = Pool()
-        invoice_obj = pool.get('account.invoice')
+        Invoice = pool.get('account.invoice')
 
-        refund = session.start.with_refund
-        invoice_ids = Transaction().context['active_ids']
+        refund = self.start.with_refund
+        invoices = Invoice.browse(Transaction().context['active_ids'])
 
         if refund:
-            for invoice in invoice_obj.browse(invoice_ids):
+            for invoice in invoices:
                 if invoice.state != 'open':
                     self.raise_user_error('refund_non_open')
                 if invoice.payment_lines:
                     self.raise_user_error('refund_with_payement')
 
-        invoice_ids = invoice_obj.credit(invoice_ids, refund=refund)
+        invoice_ids = Invoice.credit(invoices, refund=refund)
 
         data = {'res_id': invoice_ids}
         if len(invoice_ids) == 1:
             action['views'].reverse()
         return action, data
-
-CreditInvoice()
diff -r e32ff462bf6e trytond/modules/account_invoice/party.py
--- a/trytond/modules/account_invoice/party.py	Mon Sep 10 15:27:42 2012 +0200
+++ b/trytond/modules/account_invoice/party.py	Mon Sep 24 20:36:39 2012 +0200
@@ -1,37 +1,37 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 from trytond.model import ModelView, ModelSQL, fields
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 
+__all__ = ['Address', 'Party']
+__metaclass__ = PoolMeta
 
-class Address(ModelSQL, ModelView):
-    _name = 'party.address'
+
+class Address:
+    __name__ = 'party.address'
     invoice = fields.Boolean('Invoice')
 
-Address()
-
 
 class Party(ModelSQL, ModelView):
-    _name = 'party.party'
+    __name__ = 'party.party'
     customer_payment_term = fields.Property(fields.Many2One(
         'account.invoice.payment_term', string='Customer Payment Term'))
     supplier_payment_term = fields.Property(fields.Many2One(
         'account.invoice.payment_term', string='Supplier Payment Term'))
 
-    def init(self, module_name):
-        ir_model_field_obj = Pool().get('ir.model.field')
+    @classmethod
+    def __register__(cls, module_name):
+        ModelField = Pool().get('ir.model.field')
 
         # Migration from 2.2: property field payment_term renamed
         # to customer_payment_term
-        field_ids = ir_model_field_obj.search([
+        fields = ModelField.search([
                 ('name', '=', 'payment_term'),
                 ('model.model', '=', 'party.party')
                 ])
-        if field_ids:
-            ir_model_field_obj.write(field_ids, {
+        if fields:
+            ModelField.write(fields, {
                     'name': 'customer_payment_term',
                     })
 
-        super(Party, self).init(module_name)
-
-Party()
+        super(Party, cls).__register__(module_name)
